//+------------------------------------------------------------------+
//|                                                  expert watl.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


#include <stdlib.mqh>
//variabili globali
int MaxOrders = 1;
//variabili interne
double value2,value1;
double max,max_prec,min,min_prec,minimo,massimo,minimo2,massimo2;
double max2,max_prec2,min2,min_prec2;
int Slippage = 4;
double Lot = 0.1;
bool change_max,change_min;
bool change_max2,change_min2;
bool change_max_exit,change_min_exit;
bool YesStop;

int BuyStopOrder,SellStopOrder;
double opensellprice,openbuyprice;

extern double  TrailingStop = 125;  
extern double  TakeProfit   = 250;

extern bool    UseTradingHours = true;
extern bool    TradeAsianMarket = false;
extern int     StartHour1 = 0;       // Start trades after time
extern int     StopHour1 = 3;      // Stop trading after time
extern bool    TradeEuropeanMarket = true;
extern int     StartHour2 = 0;       // Start trades after time
extern int     StopHour2 = 24;      // Stop trading after time
extern bool    TradeNewYorkMarket = false;
extern int     StartHour3 = 15;       // Start trades after time
extern int     StopHour3 = 17;      // Stop trading after time

int MagicNumber;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   value2=0;
   max = 0;
   max_prec = 0;
   min = 0;
   min_prec = 0;
   change_min = false;
   change_max = false;
   
   if (!GlobalVariableCheck("vg_min"))
   GlobalVariableSet("vg_min",0);
   else minimo = GlobalVariableGet("vg_min");
   
   if (!GlobalVariableCheck("vg_max"))
   GlobalVariableSet("vg_max",0);
   else massimo = GlobalVariableGet("vg_max");
   
   if (!GlobalVariableCheck("vg_min2"))
   GlobalVariableSet("vg_min2",0);
   else minimo2 = GlobalVariableGet("vg_min2");
   
   if (!GlobalVariableCheck("vg_max2"))
   GlobalVariableSet("vg_max2",0);
   else massimo2 = GlobalVariableGet("vg_max2");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----

   
   if (UseTradingHours)
   {

     YesStop = true;
     if (TradeAsianMarket)
     {
        if (StartHour1 > 18)
        {
          if (Hour() >= StartHour1) YesStop = false;
          if (!YesStop)
          {
            if (StopHour1 < 24)
            {
              if ( Hour() <= StopHour1) YesStop = false;
            }
            if (StopHour1 >=0)
            {
              if ( Hour() <= StopHour1) YesStop = false;
            }
          }
        }
        else
        {
          if (Hour() >= StartHour1 && Hour() <= StopHour1) YesStop = false;
        }
     }
     if (YesStop)
     {
       if (TradeEuropeanMarket)
       {
         if (Hour() >= StartHour2 && Hour() <= StopHour2) YesStop = false;
       }
     }
     if (YesStop)
     {
       if (TradeNewYorkMarket)
       {
         if (Hour() >= StartHour3 && Hour() <= StopHour3) YesStop = false;
       }
     }
     if (YesStop)
     {
       return (0);
      }
   }
//----
for(int i=1;i<50;i++){
   value2=iCustom(NULL,0,"WATL",1,i);
   if(value2!=0 && value2>iOpen(NULL,0,i)){
      //max_prec = max;
      max=iHigh(NULL,0,i);
      i=50;
      value2 = 0;
      massimo2 = GlobalVariableGet("vg_max2");
      massimo = GlobalVariableGet("vg_max");
      if(max!=massimo){
            massimo2 = massimo;
            massimo = max;
            GlobalVariableSet("vg_max",massimo);
            GlobalVariableSet("vg_max2",massimo2);            
            change_max = true;
            change_max_exit = true;
      }      
   }   
   if(value2!=0 && value2<iOpen(NULL,0,i)){
      //min_prec = min;
      min=iLow(NULL,0,i);
      i=50;
      value2 = 0;
      minimo2 = GlobalVariableGet("vg_min2");
      minimo = GlobalVariableGet("vg_min");
      if(min!=minimo){
            minimo2 = minimo;
            minimo = min;
            GlobalVariableSet("vg_min",minimo);     
            GlobalVariableSet("vg_min2",minimo2);        
            change_min = true;
            change_min_exit = true;
      }      
   }   
} 



Comment("\nmassimo attuale:  ",massimo,"          massimo precedente:  ",massimo2,
        "\nminimo  attuale:  ",minimo,"           minimo  precedente:  ",minimo2
        );

if(MyOrders(1)>0  && (Ask-openbuyprice)*10000>0 ) {HandleTrailingPositions();}
if(MyOrders(2)>0  && (opensellprice-Ask)*10000>0) {HandleTrailingPositions();}

if(MyOrdersLim(1)>0 && (minimo<minimo2 )) {ControlStopPosition();CloseOrderLim(1);}
if(MyOrdersLim(2)>0 && (massimo>massimo2)){ControlStopPosition();CloseOrderLim(2);}

if(MyOrders(1)>0 && (min>openbuyprice  || (change_max && massimo<massimo2))) CloseOrder(1);                          
if(MyOrders(2)>0 && (max<opensellprice || (change_min && minimo>minimo2  ))) CloseOrder(2);

if(min!=0){
      if(change_max  && MyOrders(2)<MaxOrders && massimo<massimo2){ 
                  if(MyOrdersLim(2)<MaxOrders ) OrderSend(Symbol(),OP_SELLSTOP,Lot,minimo-20*Point,Slippage,massimo,minimo-TakeProfit*Point,"sell",MagicNumber,0,Red);
                  change_max = false;
                  opensellprice = minimo;
      }            
}                               

if(max!=0){
      if(change_min  && MyOrders(1)<MaxOrders && minimo>minimo2){ 
                  if(MyOrdersLim(1)<MaxOrders ) OrderSend(Symbol(),OP_BUYSTOP,Lot,massimo+20*Point,Slippage,minimo,massimo+TakeProfit*Point,"buy",MagicNumber,0,Blue);
                  change_min = false;
                  openbuyprice = massimo;
      }            
}                               

   
//----
   return(0);
}
//+------------------------------------------------------------------+

// procedure e funzioni
// funzione per restituire il numero ordini in essere
int MyOrders(int tipo)
{
   int count;
   int Type_Ord;
   int Ord_Total;
   Ord_Total = OrdersTotal();
   if(Ord_Total > 0) {
      for(int i = Ord_Total-1;i >= 0;i--){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         Type_Ord = OrderType();
         if(Type_Ord == OP_BUY  && tipo == 1) {count++;}
         if(Type_Ord == OP_SELL && tipo == 2) {count++;}
      }
   }
   return(count);
}
int MyOrdersLim(int tipo)
{
   int count;
   int Type_Ord;
   int Ord_Total;
   Ord_Total = OrdersTotal();
   if(Ord_Total > 0) {
      for(int i = Ord_Total-1;i >= 0;i--){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         Type_Ord = OrderType();
         if(Type_Ord == OP_BUYSTOP  && tipo == 1) count++;
         if(Type_Ord == OP_SELLSTOP && tipo == 2) count++;
      }
   }
   return(count);
}

//procedura per la chiusura degli ordini pendenti
void CloseOrder(int tipo)
{   
    int Type_Ord;
    for(int cnt=OrdersTotal()-1;cnt>=0;cnt--)
    {
      OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES);
         Type_Ord = OrderType();
         if(Type_Ord == OP_BUY  && tipo == 1) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),Slippage,Yellow);
         if(Type_Ord == OP_SELL && tipo == 2) OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),Slippage,Yellow);
    }

}

void CloseOrderLim(int tipo)
{   
    int Type_Ord;
    for(int cnt=OrdersTotal()-1;cnt>=0;cnt--)
    {
      OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES);
         Type_Ord = OrderType();
         if(Type_Ord == OP_BUYSTOP  && tipo == 1) OrderDelete(BuyStopOrder);
         if(Type_Ord == OP_SELLSTOP && tipo == 2) OrderDelete(SellStopOrder);
    }

}

void ControlStopPosition(){
	for ( int z = OrdersTotal() - 1; z >= 0; z -- ){
	     OrderSelect( z, SELECT_BY_POS );
		   if ( OrderSymbol() != Symbol() ) continue;
      	//if ( OrderMagicNumber() != aMagic ) continue;
   		switch ( OrderType() ){
		    	//case OP_BUY:		BuyOrder			= OrderOpenPrice(); break;
			   //case OP_SELL:		SellOrder		= OrderOpenPrice(); break;
			   case OP_BUYSTOP:	BuyStopOrder	= OrderTicket(); break;
			   case OP_SELLSTOP:	SellStopOrder	= OrderTicket(); break;
		   }
    }
}

int HandleModifyStop(int ord_ticket,double op, double price,double tp, color mColor)
{
    int CloseCnt, err;
    
    CloseCnt=0;
    while (CloseCnt < 3)
    {
       if (OrderModify(ord_ticket,op,price,tp,0,mColor))
       {
         CloseCnt = 3;
       }
       else
       {
          err=GetLastError();
          Print(CloseCnt," Error modifying order : (", err , ") " );
         if (err>0) CloseCnt++;
       }
    }
}

int HandleOpenPositions(double sl)
{
   int cnt;
   for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
   {
      OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() == OP_BUY)
               HandleModifyStop(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),LightGreen);

      if(OrderType() == OP_SELL)
      {
               HandleModifyStop(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),LightGreen);
      }
   }
} 


int HandleTrailingPositions()
{
   int cnt;
   
   for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
   {
      OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES);
      if ( OrderSymbol() != Symbol()) continue;
      if ( OrderMagicNumber() != MagicNumber)  continue;
      
      if(OrderType() == OP_BUY)
      {
               Delayed_TrailingStop(OP_BUY,OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderTakeProfit());
      }

      if(OrderType() == OP_SELL)
      {
               Delayed_TrailingStop(OP_SELL,OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderTakeProfit());
      }
   }
}

int ModifyOrder(int ord_ticket,double op, double price,double tp, color mColor)
{
    int CloseCnt, err;
    
    CloseCnt=0;
    while (CloseCnt < 3)
    {
       if (OrderModify(ord_ticket,op,price,tp,0,mColor))
       {
         CloseCnt = 3;
       }
       else
       {
          err=GetLastError();
          Print(CloseCnt," Error modifying order : (", err , ") " + ErrorDescription(err));
         if (err>0) CloseCnt++;
       }
    }
}

double ValidStopLoss(int type, double price, double SL)
{

   double minstop, pp;
   
   pp = MarketInfo(Symbol(), MODE_POINT);
   minstop = MarketInfo(Symbol(),MODE_STOPLEVEL);
   if (type == OP_BUY)
   {
		 if((price - SL) < minstop*pp) SL = price - minstop*pp;
   }
   if (type == OP_SELL)
   {
       if((SL-price) < minstop*pp)  SL = price + minstop*pp;  
   }

   return(SL);   
}


void Delayed_TrailingStop(int type, int ticket, double op, double os, double tp)
{
   int digits;
   double pt, pBid, pAsk, pp, BuyStop, SellStop;

   pp = MarketInfo(Symbol(), MODE_POINT);
   pt = TrailingStop * pp;
   digits = MarketInfo(Symbol(), MODE_DIGITS);
   
   if (type==OP_BUY)
   {
     pBid = MarketInfo(Symbol(), MODE_BID);
     BuyStop = pBid - pt;
     if (digits > 0) BuyStop = NormalizeDouble( BuyStop, digits);
	  BuyStop = ValidStopLoss(OP_BUY,pBid, BuyStop);   
     if (digits > 0) BuyStop = NormalizeDouble( BuyStop, digits);
     if (pBid-op > pt && os < BuyStop) ModifyOrder(ticket,op,BuyStop,tp,LightGreen);
	  return;
   }
   if (type==OP_SELL)
   {
     pAsk = MarketInfo(Symbol(), MODE_ASK);
     pt = TrailingStop * pp;
     SellStop = pAsk + pt;
     if (digits > 0) SellStop = NormalizeDouble( SellStop, digits);
     SellStop = ValidStopLoss(OP_SELL, pAsk, SellStop);  
     if (digits > 0) SellStop = NormalizeDouble( SellStop, digits);
     if (op - pAsk > pt && os > SellStop) ModifyOrder(ticket,op,SellStop,tp,DarkOrange);
	  return;
   }   
}